
// -------------------------------------------------------------
// set_ani_camera

#define set_ani_camera(p_camera,p_aniid,p_dumpnum) \
  selectCamera p_camera##,0; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum; 

// -------------------------------------------------------------
// set_current_ani_camera

#define set_current_ani_camera(p_aniid,p_dumpnum) \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum; 

// -------------------------------------------------------------
// current_interpolate_to_ani_camera

#define current_interpolate_to_ani_camera(p_seconds,p_camera,p_aniid,p_dumpnum) \
  selectCamera p_camera##,##p_seconds; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum;

// -------------------------------------------------------------
// sinwave_interpolate_to_ani_camera

#define sinwave_interpolate_to_ani_camera(p_seconds,p_camera,p_aniid,p_dumpnum) \
	setCameraInterpolationType sinwave; \
  selectCamera p_camera##,##p_seconds; \
	setCameraInterpolationType sinwave; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum;

// -------------------------------------------------------------
// linear_interpolate_to_ani_camera

#define linear_interpolate_to_ani_camera(p_seconds,p_camera,p_aniid,p_dumpnum) \
	setCameraInterpolationType linear; \
  selectCamera p_camera##,##p_seconds; \
	setCameraInterpolationType linear; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum;

// -------------------------------------------------------------
// linear_to_sinwave_interpolate_to_ani_camera

#define linear_to_sinwave_interpolate_to_ani_camera(p_seconds,p_camera,p_aniid,p_dumpnum) \
	setCameraInterpolationType linear; \
  selectCamera p_camera##,##p_seconds; \
	setCameraInterpolationType sinwave; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum;

// -------------------------------------------------------------
// sinwave_to_linear_interpolate_to_ani_camera

#define sinwave_to_linear_interpolate_to_ani_camera(p_seconds,p_camera,p_aniid,p_dumpnum) \
	setCameraInterpolationType sinwave; \
  selectCamera p_camera##,##p_seconds; \
	setCameraInterpolationType linear; \
	externInclude ani_camera_dump_##p_aniid##:dumped_camera_position_##p_dumpnum;

// -------------------------------------------------------------
// play_ani_batch

#define play_ani_batch(p_aniid) \
	externInclude ani_batch_file_##p_aniid##:play_ani_batch;

// -------------------------------------------------------------
// import_0_ani

#define import_0_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \

// -------------------------------------------------------------
// import_1_ani

#define import_1_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \

// -------------------------------------------------------------
// import_2_ani

#define import_2_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \

// -------------------------------------------------------------
// import_3_ani

#define import_3_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \

// -------------------------------------------------------------
// import_4_ani

#define import_4_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \

#define import_5_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \

#define import_6_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \

#define import_7_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \

#define import_8_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \

#define import_9_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_8_##p_aniid##.dhs; \

#define import_10_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_8_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_9_##p_aniid##.dhs; \

#define import_11_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_8_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_9_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_10_##p_aniid##.dhs; \

#define import_12_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_8_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_9_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_10_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_11_##p_aniid##.dhs; \

#define import_13_ani(p_mission,p_aninum,p_aniid) \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_batch_file_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_camera_dumps_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_0_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_1_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_2_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_3_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_4_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_5_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_6_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_7_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_8_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_9_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_10_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_11_##p_aniid##.dhs; \
  import Data/Missions/##p_mission##/ani/##p_aninum##/ani_record_12_##p_aniid##.dhs; \

// -------------------------------------------------------------
// force_unit_anim

#define force_unit_anim(p_unit_idstring,p_anim) \
	setUnitByIdString p_unit_idstring; \
	forceUnitAnimation p_anim;

