
#define CHAR_SPEECH_COUNTER_DELAY 8

#define NOISE_RADIO_WEAK 30
#define NOISE_RADIO_MEDIUM 50
#define NOISE_RADIO_STRONG 80
#define NOISE_FULL 100



//#define globals_for_executable_static_char(speechcounter, executedvar) \
//global int,speechcounter; \
//global int,executedvar;

// ----------------------------------------------------------

#define main_for_executable_static_char() \
  setValue 0; \
  setUnitVariable charspeechcounter; \
  setUnitVariable charexecuted; \
  loop; \
    wait 1; \
    getUnitVariable charspeechcounter; \
    if; \
      valueGreaterThan 0; \
    then; \
      getUnitVariable charspeechcounter; \
      addValue -1; \
      setUnitVariable charspeechcounter; \
    endif; \
  endLoop;


// ----------------------------------------------------------

#define execute_check_for_executable_static_char() \
  if; \
    isCinematicScriptRunning; \
  then; \
    return; \
  endif; \
  getUnitVariable charspeechcounter; \
  if; \
    valueGreaterThan 0; \
  then; \
    return; \
  endif; \
  setValue CHAR_SPEECH_COUNTER_DELAY; \
  setUnitVariable charspeechcounter; \
  if(not(isUnitDestroyed)); \
  then; \
    setTarget shooter; \
    setUnit shooter; \
    unitPosition; \
    restoreUnit; \
    turnToward; \
  endif;


// ----------------------------------------------------------

#define already_executed_check_for_executable_static_char(charmessage, speechsound) \
  if; \
    getUnitVariable charexecuted; \
  then; \
    if(not(isUnitDestroyed)); \
    then; \
      characterMessage charmessage; \
      unitPosition; \
      playSpeech speechsound; \
    endif; \
    return; \
  endif; \
  setValue 1; \
  setUnitVariable charexecuted;

// ----------------------------------------------------------

#define mission_variable_check_for_executable_static_char(execvariable, charmessage, speechsound) \
  if; \
    getVariable execvariable; \
  then; \
    if(not(isUnitDestroyed)); \
    then; \
      characterMessage charmessage; \
      unitPosition; \
      playSpeech speechsound; \
    endif; \
    return; \
  endif; \
  setValue 1; \
  setVariable execvariable;

// ----------------------------------------------------------

//  clearMessage;

#define char_say(p_unitidstring, p_msg, p_speechsound) \
	setUnitByIdString p_unitidstring; \
  characterMessage p_msg; \
  unitPosition; \
  playSpeech p_speechsound; \
  restoreUnit;

// ----------------------------------------------------------

//		clearMessage;

#define char_say2_wait(p_unitidstring, p_msg_id) \
  if; \
    not(isSkippingCinematic); \
	then; \
	    pushValue; \
		setUnitByIdString p_unitidstring; \
		characterMessage $( ## p_msg_id ## ); \
		preloadTemporarySound Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		listenerPosition; \
		playSpeech Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		playLipsync Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		getWaveLength Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		if; \
		then; \
		else; \
		  getLocaleStringLength p_msg_id; \
			multiplyValue 50; \
			addValue 1000; \
		endif; \
		waitValue; \
		popValue; \
		restoreUnit; \
	endif;

//		playLipsync Data/Sounds/Vocals/demo_speech.wav;

#define char_say2(p_unitidstring, p_msg_id) \
  if; \
    not(isSkippingCinematic); \
	then; \
		setUnitByIdString p_unitidstring; \
		characterMessage $( ## p_msg_id ## ); \
		preloadTemporarySound Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		listenerPosition; \
		playSpeech Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		playLipsync Data/Sounds/Vocals/ ## p_msg_id ## .wav; \
		restoreUnit; \
	endif;

#define char_say_empty(p_unitidstring, p_msg_id) \
  if; \
    not(isSkippingCinematic); \
	then; \
		setUnitByIdString p_unitidstring; \
		characterMessageNoFace $( ## p_msg_id ## ); \
		restoreUnit; \
	endif;

// ----------------------------------------------------------

#define start_conversation(p_unitidstring1, p_unitidstring2) \
  if;getScriptProcessId;not(isScriptProcessOfValueCinematic); \
  then; \
    wait_until_no_cinematic(); \
  endif; \
  get_lock(lock_conversation); \
	setUnitByIdString p_unitidstring1; \
	setConversationUnitLeft; \
	setUnitByIdString p_unitidstring2; \
	setConversationUnitRight; \
	startConversation; \
  characterMessage ""; \
	setUnitByIdString p_unitidstring1; \
  characterMessage ""; \
	restoreUnit; \
	set_idle_animation(p_unitidstring1, default); \
	set_expression(p_unitidstring1, default); \
	set_idle_animation(p_unitidstring2, default); \
	set_expression(p_unitidstring2, default); \
  setUnitByIdString p_unitidstring1;\
  setConversationNoiseForUnit 0;\
  setUnitByIdString p_unitidstring2;\
  setConversationNoiseForUnit 0;\
  restoreUnit;\
//  clearMessage;

#define start_conversation_single(p_unitidstring) \
  if;getScriptProcessId;not(isScriptProcessOfValueCinematic); \
  then; \
    wait_until_no_cinematic(); \
  endif; \
  get_lock(lock_conversation); \
	setUnitByIdString p_unitidstring; \
	setConversationUnitLeft; \
	startConversation; \
	restoreUnit; \
  setUnitByIdString p_unitidstring;\
  setConversationNoiseForUnit 0;\
  restoreUnit;\
//  clearMessage;

#define start_conversation_empty() \
  if;getScriptProcessId;not(isScriptProcessOfValueCinematic); \
  then; \
    wait_until_no_cinematic(); \
  endif; \
  get_lock(lock_conversation); \
	startConversation; \

#define end_conversation() \
	stopAllSpeeches; \
	cleanTemporarySoundCache; \
	endConversation; \
  clearMessage; \
  free_lock(lock_conversation)

#define wait_until_conversation_over() \
  _externCallPush;\
  wait 1;get_lock(lock_conversation);free_lock(lock_conversation);\
  _externCallPop

#define set_idle_animation(p_unitidstring, idle_animation)\
  devMessage IDLE: p_unitidstring idle_animation; \
	setUnitByIdString p_unitidstring; \
	setConversationIdleAnimationForUnit idle_animation; \
	restoreUnit;

#define set_expression(p_unitidstring, expression_animation)\
  devMessage EXPRESSION: p_unitidstring expression_animation; \
	setUnitByIdString p_unitidstring; \
	setConversationExpressionAnimationForUnit expression_animation; \
	restoreUnit;

  
#define set_face_animation(p_unitidstring, idle_animation, expression_animation)\
  set_idle_animation(p_unitidstring, idle_animation);\
  set_expression(p_unitidstring, expression_animation);

#define set_face_noise(p_unitidstring, noise_level)\
  setUnitByIdString p_unitidstring;\
  setConversationNoiseForUnit noise_level;\
  devMessage NOISE: p_unitidstring noise_level;

// ----------------------------------------------------------

#define static_char_has_executed() \
  setValue CHAR_SPEECH_COUNTER_DELAY; \
  setUnitVariable charspeechcounter;


// ----------------------------------------------------------

// TODO: should check that the unit actually exists, return false
// if it does not. (may already do that?)
#define is_char_alive(p_unitidstring) \
	setUnitByIdString p_unitidstring; \
	not(isUnitDestroyed); \
  restoreUnit;

// ----------------------------------------------------------

#define force_player_idle() \
  setUnitByIdString "player1"; \
  disableControls; \
  forceUnitAnimation idle1; \
  disableScrolly; \
  restoreUnit;

// ----------------------------------------------------------

#define end_force_player_idle() \
  enableScrolly; \
  setUnitByIdString "player1"; \
  endForcedUnitAnimation; \
  enableControls; \
  restoreUnit; 

// ----------------------------------------------------------

#define drop_item_when_destroyed(p_item) \
	if; \
    isUnitDestroyed; \
	then; \
		unitPosition; \
		setPositionHeightOnGround; \
		addItem p_item; \
	endif;

