
// general macros

#define if(x) \
	if; \
		x; \


#define if_then_else(x, th, el) \
	if; \
		x; \
	then; \
		th; \
	else; \
		el; \
	endif; \


#define not(x) \
	x; \
	notValue; \


#define and(x,y) \
	x; \
	pushValue; \
	y;  \
	setSecondary; \
  popValue; \
	andSecondary;

#define or(x,y) \
	x; \
	pushValue; \
	y;  \
	setSecondary; \
  popValue; \
	orSecondary;

#define command_values_equal(x, y) \
	x; \
	setSecondary; \
	y; \
	decreaseSecondary; \
	if; \
		getSecondary; \
	then; \
	  setValue 0; \
	else; \
	  setValue 1; \
	endif;
		

#define command_value_greater_than(x, y) \
	x; \
	setSecondary; \
	y; \
	decreaseSecondary; \
	if; \
		getSecondary; \
		valueGreaterThan 0; \
	then; \
	  setValue 1; \
	else; \
	  setValue 0; \
	endif;


#define command_value_less_than(x, y) \
	x; \
	setSecondary; \
	y; \
	decreaseSecondary; \
	if; \
		getSecondary; \
		valueLessThan 0; \
	then; \
	  setValue 1; \
	else; \
	  setValue 0; \
	endif;
		

#define error(str) \
	error str; \
	error error macro at file __FILE__ line __LINE__;


#define DEVASSERT() \
  if;\
	then;\
	else; \
	  error DEVASSERT macro at file __FILE__ line __LINE__; \
  endif;\
	devAssert;


#define assert(x) \
  if;\
	  x; \
	then;\
	else; \
	  error assert macro at file __FILE__ line __LINE__; \
  endif;\
	devAssert;


#define int_call(func) \
	call func; \
	popValue; \


#define intvar_call(int, func) \
	call func; \
	popValue; \
	setVariable var; \


#define void_call_intvar(func, var) \
	getVariable var; \
	call func; \


#define void_call_int(func) \
	call func; \


#define return(x) \
	setValue x; \
	pushValue; \
	return; \


//#define endSub \
//	return; \
//	endSub; 


#define int_sub(name) \
	sub name; \


#define void_sub(name) \
	sub name; 


#define void_sub_int(name, int) \
	sub name; \
	popValue; \


#define is_variable_greater_than(name, value) \
	getVariable name; \
	valueGreaterThan value;


#define is_variable_less_than(name, value) \
	getVariable name; \
	valueLessThan value;


#define breakloop_if_variable_greater_than(name, value) \
    if; \
      is_variable_greater_than(name, value); \
    then; \
      breakLoop; \
    endif;


#define breakloop_if_variable_less_than(name, value) \
    if; \
      is_variable_less_than(name, value); \
    then; \
      breakLoop; \
    endif;


#define is_var(name, value) \
	getVariable name; \
	valueEquals value;


#define set_var(name,value) \
	setValue value; \
	setVariable name;


#define set_variable_to(name,value) \
	setValue value; \
	setVariable name;


#define add_variable_by_one(name) \
	getVariable name; \
	addValue 1; \
	setVariable name;


#define decrease_variable_by_one(name) \
	getVariable name; \
	addValue -1; \
	setVariable name;


#define add_variable_by(p_name, p_value) \
	getVariable p_name; \
	addValue p_value; \
	setVariable p_name;


#define add_variable_by_current_value(p_name) \
  pushValue; \
	getVariable p_name; \
	setSecondary; \
	popValue; \
	addSecondary; \
	getSecondary; \
	setVariable p_name;


#define decrease_variable_by_current_value(p_name) \
  pushValue; \
	getVariable p_name; \
	setSecondary; \
	popValue; \
	decreaseSecondary; \
	getSecondary; \
	setVariable p_name;


#define add_variable_by_command_value(p_name,p_command) \
	getVariable p_name; \
	setSecondary; \
	p_command; \
	addSecondary; \
	getSecondary; \
	setVariable p_name;


#define decrease_variable_by_command_value(p_name,p_command) \
	getVariable p_name; \
	setSecondary; \
	p_command; \
	decreaseSecondary; \
	getSecondary; \
	setVariable p_name;


// rotate from 0 -> max value (inclusive), then back to zero
#define rotate_variable_forward(name, max_rotate_value) \
	getVariable name; \
	addValue 1; \
	setVariable name; \
	if; \
	  valueGreaterThan max_rotate_value; \
	then; \
	  setValue 0; \
		setVariable name; \
	endif;

// rotate from max value (inclusive) -> 0, then back to max value
#define rotate_variable_backward(name, max_rotate_value) \
	getVariable name; \
	addValue -1; \
	setVariable name; \
	if; \
	  valueLessThan 0; \
	then; \
	  setValue max_rotate_value; \
		setVariable name; \
	endif;


// maxvalue exclusive
#define stepped_random(p_maxvalue,p_stepsize) \
	random p_maxvalue; \
	divideValue p_stepsize; \
	multiplyValue p_stepsize;



//#define return \
//	return; 


