#define HEAD_WEISS 3
#define HEAD_SMITH 4
#define HEAD_RODMAN 5
#define HEAD_CARTER 11
#define HEAD_WALLACE 12

#define MAX_WAIT_TIME 10
// game specific stuff

#define end_forced_unit_animation_for_all_players()\
  setUnitByIdString player1;endForcedUnitAnimation;\
  setUnitByIdString player2;\
  if;\
    isUnitAvailable current;\
  then;\
    endForcedUnitAnimation;\
  endif;\
  setUnitByIdString player3;\
  if;\
    isUnitAvailable current;\
  then;\
    endForcedUnitAnimation;\
  endif;\
  setUnitByIdString player4;\
  if;\
    isUnitAvailable current;\
  then;\
    endForcedUnitAnimation;\
  endif;
  
#define push_values()\
  pushValue;\
  getSecondary;\
  pushValue

#define pop_values()\
  popValue;\
  setSecondary;\
  popValue

#define get_lock(lock_name)\
  global int, lock_name;\
  loop;\
    if;\
      or(not(getVariable lock_name), isSkippingCinematic);\
    then;\
      getScriptProcessId;\
      setVariable lock_name;\
      breakLoop;\
    endif;\
    wait 1;\
  endLoop;\
  devMessage "Lock acquired";\
  devMessage __FILE__ line __LINE__;
  
  
#define free_lock(lock_name)\
  setValue 0;\
  setVariable lock_name;\
  devMessage "Lock freed";\
  devMessage __FILE__ line __LINE__;
  

#define wait_until_calm()\
  _externCallPush;\
  push_values();\
  setValue MAX_WAIT_TIME;\
  setSecondary;\
  loop;\
    setUnitByIdString player1;\
    unitPosition;\
    if;\
      not(hostilesNearPosition 8);\
    then;\
      breakLoop;\
    endif;\
    if;\
      getSecondary;\
      addValue -1;\
      setSecondary;\
      valueEquals 0;\
    then;\
      breakLoop;\
    endif;\
    wait 1;\
  endLoop;\
  restoreUnit;\
  pop_values();\
  _externCallPop;\

#define save_game()\
  externInclude respawn_location:execute

#define hidepoint_position() \
	if;\
    doesUnitExistWithIdString "hidepoint";\
	then;\
	  if;\
      isUnitAvailable current;\
		then;\
		  getUnitId;\
		else;\
		  setValue 0;\
		endif;\
		pushValue;\
    setUnitByIdString "hidepoint";\
		unitPosition;\
		if;\
		  popValue;\
    then;\
		  setUnitById;\
		else;\
		  setUnit null;\
		endif;\
	else;\
    setPosition 10,10;\
	endif;

#define hide_unit(unit)\
  setUnitByIdString unit;\
  hidepoint_position();\
  warpUnitToPosition;\
  stopMovement;\
  hideUnit;\
  restoreUnit

#define show_unit(unit)\
  setUnitByIdString unit;\
  unitSpawnPosition;\
  warpUnitToPosition;\
  showUnit;\
  stopMovement;\
  restoreUnit

#define hide_current_unit()\
  hidepoint_position();\
  warpUnitToPosition;\
  stopMovement;\
  hideUnit

#define show_current_unit()\
  unitSpawnPosition;\
  warpUnitToPosition;\
  showUnit;\
  stopMovement

#define warp_unit(unit, dest_unit) \
  setUnitByIdString dest_unit;unitPosition;getUnitAngle;setSecondary;\
  setUnitByIdString unit;warpUnitToPosition;getSecondary;setUnitRotationYToValue;stopMovement;restoreUnit

#define push_player_position() \
  setUnitByIdString player1;\
  unitPosition;\
  setSecondaryPosition;\
  getUnitAngle;\
  setSecondary;\
  restoreUnit

#define pop_player_position() \
  setUnitByIdString player1;\
  getSecondaryPosition;\
  warpUnitToPosition;\
  getSecondary;\
  setUnitRotationYToValue;\
  setUnitByIdString player2;\
  if;\
    isUnitAvailable current;\
  then;\
    getSecondaryPosition;\
    warpUnitToPosition;\
    getSecondary;\
    setUnitRotationYToValue;\
  endif;\
  setUnitByIdString player3;\
  if;\
    isUnitAvailable current;\
  then;\
    getSecondaryPosition;\
    warpUnitToPosition;\
    getSecondary;\
    setUnitRotationYToValue;\
  endif;\
    setUnitByIdString player4;\
  if;\
    isUnitAvailable current;\
  then;\
    getSecondaryPosition;\
    warpUnitToPosition;\
    getSecondary;\
    setUnitRotationYToValue;\
  endif;\
  restoreUnit 

// -------------------------------------------------------------
// position_closer_than

#define position_closer_than(p_distance) \
  distanceToPosition; \
  valueLessThan p_distance;

// -------------------------------------------------------------
// position_further_than

#define position_further_than(p_distance) \
  distanceToPosition; \
  valueGreaterThan p_distance;

// -------------------------------------------------------------

#define is_unit_var(name, value) \
	getUnitVariable name; \
	valueEquals value;

// -------------------------------------------------------------

#define set_unit_var(name,value) \
	setValue value; \
	setUnitVariable name;


// -------------------------------------------------------------
// assert_true_value

#ifdef DEBUG

//	#define assert_true_value(commands)
//		if(not(commands));
//		then;
//			error("assert_true_value");
//		endif; 

	#define assert_true_value(commands) \
	  commands; \
		DEVASSERT();

#else

	#define assert_true_value()

#endif


// -------------------------------------------------------------
// assert_unit_exists

#ifdef DEBUG

	#define assert_unit_exists() \
		if(not(isUnitAvailable current)); \
		then; \
		  setValue 0; \
			DEVASSERT(); \
			return; \
		endif; 

#else

	#define assert_unit_exists()

#endif


// -------------------------------------------------------------
// assert_unit_is_human_player

#ifdef DEBUG

	#define assert_unit_is_human_player() \
		if(not(command_values_equal(getSinglePlayer, unitOwnerPlayer;getPlayer))) \
		then; \
		  setValue 0; \
			DEVASSERT(); \
			return; \
		endif; 

#else

	#define assert_unit_is_human_player()

#endif



#define set_mission_objective_range(range) setMissionObjectiveRange range
#define set_mission_objective_to_position() setMissionObjectiveToPosition
#define add_primary_mission_objective(string) addPrimaryMissionObjective string;clearMessage;startScriptProcess objectives_updated
#define add_secondary_mission_objective(string) if;not(doesMissionObjectiveExist string);then;addSecondaryMissionObjective;clearMessage;startScriptProcess objectives_updated;endif
#define remove_mission_objective(string) removeMissionObjective string
#define complete_mission_objective(string) completeMissionObjective string;  startScriptProcess objectives_updated
#define is_mission_objective_complete(string) isMissionObjectiveComplete string
#define update_mission_objective_position(string, position) \
  if;\
    doesMissionObjectiveExist string;\
  then;\
    setUnitByIdString position;\
    unitPosition;\
    restoreUnit;\
    updateMissionObjectiveToPosition string;\
  endif;
 
#define add_primary_objective(name, position, range, layer) \
  setUnitByIdString position;\
  unitPosition;\
  restoreUnit;\
  setMissionObjectiveToPosition;\
  setMissionObjectiveRange range;\
  setMissionObjectiveLayer layer;\
  addPrimaryMissionObjective name;\
  startScriptProcess objectives_updated

#define add_primary_objective_top(name, position, range, layer) \
  setUnitByIdString position;\
  unitPosition;\
  restoreUnit;\
  setMissionObjectiveToPosition;\
  setMissionObjectiveRange range;\
  setMissionObjectiveLayer layer;\
  addActiveMissionObjective name;\
  startScriptProcess objectives_updated

  
#define add_secondary_objective(name, position, range, layer) \
  if;not(doesMissionObjectiveExist name);then;\
  setUnitByIdString position;\
  unitPosition;\
  restoreUnit;\
  setMissionObjectiveToPosition;\
  setMissionObjectiveRange range;\
  setMissionObjectiveLayer layer;\
  addSecondaryMissionObjective name;\
  startScriptProcess objectives_updated;\
  endif

  
// -------------------------------------------------------------
// return_if_part_exists

#define return_if_part_exists(parttype) \
  toRootPart; \
	if; \
    seekSubPart parttype; \
	then; \
	  return; \
	endif;

//  seekSubPart parttype  
//	if 
//	  isPartAvailable 
//  then 
//    return 
//  endif 

// -------------------------------------------------------------
// ammo_pickup_if_part_exists

#define ammo_pickup_if_part_exists(parttype, ammopickupscript) \
  toRootPart; \
  if; \
    seekSubPart parttype; \
  then; \
    externInclude ammopickupscript:pickup; \
    return; \
  endif;


// -------------------------------------------------------------
// add_player_part

#define add_player_part(parttype) \
  if; \
    doesUnitExistWithIdString "player1"; \
  then; \
    setUnitByIdString "player1"; \
    toRootPart; \
    addSubPart parttype; \
  endif; \
  if; \
    doesUnitExistWithIdString "player2"; \
  then; \
    setUnitByIdString "player2"; \
    toRootPart; \
    addSubPart parttype; \
  endif; \
  if; \
    doesUnitExistWithIdString "player3"; \
  then; \
    setUnitByIdString "player3"; \
    toRootPart; \
    addSubPart parttype; \
  endif; \
  if; \
    doesUnitExistWithIdString "player4"; \
  then; \
    setUnitByIdString "player4"; \
    toRootPart; \
    addSubPart parttype; \
  endif; \
  restoreUnit; 

// -------------------------------------------------------------
// return_if_part_does_not_exist

#define return_if_part_does_not_exist(parttype) \
  toRootPart; \
	if; \
    seekSubPart parttype; \
		notValue; \
	then; \
	  return; \
	endif;


// -------------------------------------------------------------
// add_player_ammo

#define add_player_ammo(ammotype, amount) \
  toRootPart; \
  seekSubPart ammotype; \
	if; \
		notValue; \
	then; \
		error("add_player_ammo, unit has no such ammotype"); \
	  return; \
	endif; \
	if; \
    addAmmoToPart amount; \
	then; \
	  setValue 1; \
	else; \
	  sharedLocal int,hint_item_full_time_ ## ammotype ## ; \
	  elapsedMissionTime; \
		setSecondary; \
		getVariable hint_item_full_time_ ## ammotype ## ; \
		decreaseSecondary; \
		getSecondary; \
		if; \
		  valueGreaterThan 3; \
		then; \
	    elapsedMissionTime; \
		  setVariable hint_item_full_time_ ## ammotype ## ; \
	    hintMessage $(hint_item_full_ ## ammotype ## ); \
		endif; \
	  setValue 0; \
  endif;


// -------------------------------------------------------------
// movie_cinematic_start

#define movie_cinematic_start() \
  startCinematic; \
  hideGUI; \
  movieAspectRatio;

// -------------------------------------------------------------
// movie_cinematic_end

#define movie_cinematic_end() \
  normalAspectRatio; \
  showGUI; \
  endCinematic;

// -------------------------------------------------------------
// ingame_cinematic_start

#define ingame_cinematic_start() \
  startCinematic;

// -------------------------------------------------------------
// ingame_cinematic_end

#define ingame_cinematic_end() \
  endCinematic;

// -------------------------------------------------------------
// seek_door_with_lock

#define seek_door_with_lock(locktype) \
  _externCallPush; \
  setPlayer 2; \
	setFirstOwnedUnit; \
	loop; \
    if(not(isUnitAvailable current)); \
		then; \
		  breakLoop; \
		endif; \
		toRootPart; \
		if(seekSubPart locktype); \
		then; \
		  breakLoop; \
		endif; \
		setNextOwnedUnit; \
  endLoop; \
  _externCallPop;
		 
	

// -------------------------------------------------------------
// open_remote_door_with_beeps

#define open_remote_door_with_beeps(locktype, variable) \
  seek_door_with_lock(locktype); \
	hideGUI; \
  listenerPosition; \
  playSoundEffect "Data/Sounds/Computers/computerbeeps.wav"; \
  waitAccurate 800; \
  setValue 1; \
  setVariable variable; \
  waitAccurate 400; \
  if; \
    isUnitAvailable current; \
  then; \
    setCameraTimeFactor 1.0f; \
    copyCameraTo cinematic1; \
    selectCamera cinematic1,0; \
    unitPosition; \
    setCameraPositionNear; \
    wait 1; \
    wait 1; \
    selectCamera normal,0; \
  endif; \
  showGUI;


// -------------------------------------------------------------
// command_nearby_units_of_owner_and_type

#define command_nearby_units_of_owner_and_type(do_command, command_player, command_unittype, command_distance) \
  _externCallPush; \
  setPlayer command_player; \
  setFirstOwnedUnit; \
  loop; \
    if(not(isUnitAvailable current)); \
    then; \
      breakLoop; \
    endif; \
    if(not(isUnitType command_unittype)); \
    then; \
      setNextOwnedUnit; \
      restartLoop; \
    endif; \
    distanceToPosition; \
    if(valueLessThan command_distance); \
    then; \
      do_command; \
    endif; \
    setNextOwnedUnit; \
  endLoop; \
  _externCallPop;

// -------------------------------------------------------------
// distance_to_player_unit 

// FIXME: gives distance player1 only! should be to nearest player.

#define distance_to_player_unit() \
  setPlayer 0; \
  setFirstOwnedUnit; \
  unitPosition; \
  restoreUnit; \
	distanceToPosition;

// -------------------------------------------------------------
// is_player_closer_than

// NOTE: any player (unit of side 0) will do, not just player 1

#define is_player_closer_than(distance) \
  unitPosition; \
  setPlayer 0; \
  ownedNearPosition distance; \
  valueGreaterThan 0;

// -------------------------------------------------------------
// substring

// FIXME: behaves badly if start position + strlength greater than 
// the string length, and possibly in other special cases too..
// 

#define substring(startpos, strlength) \
  stringLength; \
	setSecondary; \
	setValue startpos; \
	addValue strlength; \
	decreaseSecondary; \
  substringFromEndByValue; \
	substringFromStart strlength;


// -------------------------------------------------------------
// radio_dialog_nowait

#define radio_dialog_nowait(charmessage, speechsound) \
  listenerPosition; \
  characterMessage charmessage; \
  playSpeech speechsound; \
  restoreUnit;

// -------------------------------------------------------------
// execute_tip_wait_player

#define execute_tip_wait_player(rangemeters) \
  unitPosition; \
  setAreaCenterToPosition; \
  setValue rangemeters; \
  setAreaRangeToValue; \
  setValue 15; \
  setAreaClipToValue; \
  setPlayer 0; \
  loop; \
    areaListenToPlayerUnits; \
    random 200; \
    addValue 300; \
    waitValue; \
    if; \
      hasAreaTriggered; \
    then; \
      breakLoop; \
    endif; \
  endLoop;

// -------------------------------------------------------------
// wait_roughly_until_player_closer_than

#define wait_roughly_until_player_closer_than(rangemeters) \
  unitPosition; \
  setAreaCenterToPosition; \
  setValue rangemeters; \
  setAreaRangeToValue; \
  setValue 15; \
  setAreaClipToValue; \
  setPlayer 0; \
  loop; \
    areaListenToPlayerUnits; \
    random 2000; \
    addValue 1000; \
    waitValue; \
    if; \
      hasAreaTriggered; \
    then; \
      breakLoop; \
    endif; \
  endLoop;

  //unitPosition; \
  //setPlayer 0; \
  //loop; \
  //  if; \
  //    ownedNearPosition rangemeters; \
  //  then; \
  //    breakLoop; \
  //  endif; \
  //  wait 2; \
  //endLoop; 

// -------------------------------------------------------------
// wait_until_hostile_closer_scriptrange

#define wait_until_hostile_closer_than_scriptrange() \
  unitPosition; \
  setAreaCenterToPosition; \
  getUnitVariable scriptrange; \
	divideValue 10; \
  setAreaRangeToValue; \
  getUnitVariable scriptclip; \
  setAreaClipToValue; \
  setPlayer 1; \
  loop; \
    areaListenToPlayerUnits; \
    random 2000; \
    addValue 1000; \
    waitValue; \
    if; \
      hasAreaTriggered; \
    then; \
      breakLoop; \
    endif; \
  endLoop;

// -------------------------------------------------------------
// wait_roughly_until_player_closer_scriptrange

#define wait_roughly_until_player_closer_than_scriptrange() \
  unitPosition; \
  setAreaCenterToPosition; \
  getUnitVariable scriptrange; \
	divideValue 10; \
  setAreaRangeToValue; \
  getUnitVariable scriptclip; \
  setAreaClipToValue; \
  setPlayer 0; \
  loop; \
    areaListenToPlayerUnits; \
    random 2000; \
    addValue 1000; \
    waitValue; \
    if; \
      hasAreaTriggered; \
    then; \
      breakLoop; \
    endif; \
  endLoop;

  //unitPosition; \
  //setPlayer 0; \
  //loop; \
  //  if; \
  //    getUnitVariable scriptrange; \
  //    divideValue 10; \
  //    ownedNearPositionByValue; \
  //  then; \
  //    breakLoop; \
  //  endif; \
  //  wait 2; \
  //endLoop; 

// -------------------------------------------------------------
// wait_until_player_closer_than

#define wait_until_player_closer_than(rangemeters) \
  wait_roughly_until_player_closer_than(rangemeters)

  //unitPosition; \
  //setPlayer 0; \
  //loop; \
  //  if; \
  //    ownedNearPosition rangemeters; \
  //  then; \
  //    breakLoop; \
  //  endif; \
  //  waitAccurate 500; \
  //endLoop; 

// -------------------------------------------------------------
// wait_until_player_closer_scriptrange

// PALAUTA
#define wait_until_player_closer_than_scriptrange() \
wait_roughly_until_player_closer_than_scriptrange()
//  unitPosition; \
//  setPlayer 0; \
//  loop; \
//    if; \
//      getUnitVariable scriptrange; \
//      divideValue 10; \
//      ownedNearPositionByValue; \
//    then; \
//      breakLoop; \
//    endif; \
//    waitAccurate 500; \
//  endLoop;     
// -------------------------------------------------------------
// wait_accurately_until_player_closer_scriptrange

#define wait_until_all_players_closer_than_scriptrange() \
  _externCallPush;\
    sharedLocal int, current_scriptrange;\
    loop;\
      restoreUnit;\
      waitAccurate 500;\
      wait_until_player_closer_than_scriptrange();\
      unitPosition;\
      getUnitVariable scriptrange;multiplyValue 10;setVariable current_scriptrange;\
      if;\
        setUnitByIdString player1;\
        accurateDistanceToPosition;\
        decreaseVariableFromValue current_scriptrange;\
        printValue;\
        valueGreaterThan 0;\
      then;\
        restartLoop;\
      endif;\
      setValue 0;pushValue;\
      if;\
        setUnitByIdString player2;\
        isUnitAvailable current;\
      then;\
        if;\
          accurateDistanceToPosition;\
          decreaseVariableFromValue current_scriptrange;\
          valueGreaterThan 0;\
        then;\
          popValue;setValue 1;pushValue;\
        endif;\
      endif;\
      if;\
        setUnitByIdString player3;\
        isUnitAvailable current;\
      then;\
        if;\
          accurateDistanceToPosition;\
          decreaseVariableFromValue current_scriptrange;\
          valueGreaterThan 0;\
        then;\
          popValue;setValue 1;pushValue;\
        endif;\
      endif;\
      if;\
        setUnitByIdString player4;\
        isUnitAvailable current;\
      then;\
        if;\
          accurateDistanceToPosition;\
          decreaseVariableFromValue current_scriptrange;\
          valueGreaterThan 0;\
        then;\
          popValue;setValue 1;pushValue;\
        endif;\
      endif;\
      if;\
        popValue;\
      then;\
        restartLoop;\
      endif;\
      breakLoop;\
    endLoop;\
    restoreUnit;\
  _externCallPop

#define wait_accurately_until_player_closer_than_scriptrange() \
	wait_roughly_until_player_closer_than_scriptrange()

  //unitPosition; \
  //setPlayer 0; \
  //loop; \
  //  if; \
  //    getUnitVariable scriptrange; \
  //    divideValue 10; \
  //    ownedNearPositionByValue; \
  //  then; \
  //    breakLoop; \
  //  endif; \
  //  waitAccurate 230; \
  //endLoop; 

#define wait_until_no_cinematic() \
  _externCallPush;\
  loop; \
    if;not(isCinematicScriptRunning);then;breakLoop;endif; \
    waitAccurate 100; \
  endLoop; \
  _externCallPop;
    
// -------------------------------------------------------------
// wait_until_no_cinematic_and_player_closer_than

#define wait_until_no_cinematic_and_player_closer_than(rangemeters) \
  unitPosition; \
  setPlayer 0; \
  loop; \
    isCinematicScriptRunning; \
    setSecondary; \
    if; \
      ownedNearPosition rangemeters; \
      andNotSecondary; \
    then; \
      breakLoop; \
    endif; \
    waitAccurate 500; \
  endLoop;

// -------------------------------------------------------------
// wait_until_variable_set

#define wait_until_variable_set(p_varname) \
  loop; \
    if; \
      getVariable p_varname; \
    then; \
      breakLoop; \
    endif; \
    waitAccurate 200; \
  endLoop;
  
#define wait_until_variable_not_set(p_varname) \
  loop; \
    if; \
      not(getVariable p_varname); \
    then; \
      breakLoop; \
    endif; \
    waitAccurate 200; \
  endLoop;  

#define wait_until_variable_set_limited(p_varname, max_time) \
  setValue 0;setSecondary;\
  loop; \
    if; \
      getVariable p_varname; \
    then; \
      breakLoop; \
    endif; \
    getSecondary;\
    addValue 1;\
    setSecondary;\
    if; \
      valueGreaterThan max_time; \
    then; \
      breakLoop; \
    endif; \
    waitAccurate 1000; \
  endLoop;

#define wait_until_player_closer_than_one_scriptrange(condition_variable) \
  global int, condition_variable;\
  wait_until_player_closer_than_scriptrange();\
  if;\
    getVariable condition_variable;\
  then;\
    return;\
  endif;\
  set_var(condition_variable, 1);\

#define wait_until_all_players_closer_than_one_scriptrange(condition_variable) \
  global int, condition_variable;\
  wait_until_all_players_closer_than_scriptrange();\
  if;\
    getVariable condition_variable;\
  then;\
    return;\
  endif;\
  set_var(condition_variable, 1);\

#define move_unit_to_target(target_unit) \
  getUnitId;pushValue;\
  setUnitByIdString target_unit;unitPosition;getUnitAngle;setSecondary;\
  popValue;setUnitById;\
  stopFollowPlayer;\
  moveToPosition;\
  warpUnitToPosition;\
  stopMovement;\
  getSecondary;setUnitRotationYToValue;
// -------------------------------------------------------------
// return_if_cinematic_running

#define return_if_cinematic_running() \
  if; \
    isCinematicScriptRunning; \
  then; \
    return; \
  endif;


// -------------------------------------------------------------
// return_if_character_unit_exists

#define return_if_character_unit_exists(charname) \
  setUnitByCharacterName charname; \
  if; \
    isUnitAvailable current; \
  then; \
    restoreUnit; \
    return; \
  endif; \
  restoreUnit;

// -------------------------------------------------------------
// unit_position_with_offset_cm

#define unit_position_with_offset_cm(x_offset, z_offset) \
  unitPosition; \
  movePositionX x_offset; \
  movePositionZ z_offset;

// -------------------------------------------------------------
// move_unit_with_world_offset_cm

#define move_unit_with_world_offset_cm(x_offset, z_offset) \
  unitPosition; \
  movePositionX x_offset; \
  movePositionZ z_offset; \
  warpUnitToPosition; \
	stopMovement;

// -------------------------------------------------------------
// toggle_door_near

#define toggle_door_near(p_unit_id_string, p_door_type) \
  setUnitByIdString p_unit_id_string; \
	unitPosition; \
	findClosestUnitOfType p_door_type; \
  makeUnitExecute; \
	restoreUnit;

// -------------------------------------------------------------
// open_door_near

#define open_door_near(p_unit_id_string, p_door_type) \
  setUnitByIdString p_unit_id_string; \
	unitPosition; \
	findClosestUnitOfType p_door_type; \
  if;  \
    not(getUnitVariable dooropen); \
  then; \
    makeUnitExecute; \
	else; \
	  devMessage "open_door_near - nothing done, door was already open."; \
	endif; \
	restoreUnit;

// -------------------------------------------------------------
// close_door_near

#define close_door_near(p_unit_id_string, p_door_type) \
  setUnitByIdString p_unit_id_string; \
	unitPosition; \
	findClosestUnitOfType p_door_type; \
  if;  \
    getUnitVariable dooropen; \
  then; \
    makeUnitExecute; \
	else; \
	  devMessage "close_door_near - nothing done, door was already closed."; \
	endif; \
	restoreUnit;


// -------------------------------------------------------------
// close_door_near

// -------------------------------------------------------------
// return_if_not_hostile

#define return_if_not_hostile(thetarget) \
  if; \
    not(isHostile thetarget); \
  then; \
    return; \
  endif; 

// -------------------------------------------------------------
// return_if_already_has_target

#define return_if_already_has_target() \
  if; \
    hasTarget; \
  then; \
    return; \
  endif; 

// -------------------------------------------------------------
// random_chance_one_of

#define random_chance_one_of(many) \
	not(random many);

// -------------------------------------------------------------
// return_if_destroyed

#define breakloop_if_destroyed() \
  if; \
    isUnitDestroyed; \
  then; \
    breakLoop; \
  endif; 


// -------------------------------------------------------------
// idle_sound_counter

// note: this global variable used to be sharedLocal (but that would behave differently)

//  global int,snd_##unittype##_last_time;

#define idle_sound_counter(unittype, sounddelay) \
	elapsedMissionTime; \
	setSecondary; \
	getUnitVariable last_sound; \
  decreaseSecondary; \
	getSecondary; \
	if; \
		valueGreaterThan sounddelay; \
	then; \
	  elapsedMissionTime; \
	  setUnitVariable last_sound; \
    setValue 1;\
  else;\
    setValue 0;\
	endif; \


//#define idle_sound_counter(unittype, sounddelay) \
//  \
//  global int,last_##unittype##_sound_counter;\
//  \
//  waitAccurate 70;\
//  \
//  is_player_closer_than(25);\
//  setSecondary;\
//  \
//  getVariable last_##unittype##_sound_counter;\
//  addValue 1;\
//  setVariable last_##unittype##_sound_counter;\
//  \
//  if;\
//    valueGreaterThan sounddelay;\
//    andSecondary;\
//  then;\
//    setValue 0;\
//    setVariable last_##unittype##_sound_counter;\
//    setValue 1;\
//  else;\
//    setValue 0;\
//  endif;

// -------------------------------------------------------------
// alien_drop_upgrades_if_destroyed

#define alien_drop_upgrades_if_destroyed(p_minupg, p_maxupg) \
  setValue p_minupg; setVariable alien_drop_upg_min; \
  setValue p_maxupg; setVariable alien_drop_upg_max; \
	externInclude common_alien_ai:drop_upgradeparts_if_destroyed;


// -------------------------------------------------------------
// is_unit_firing

#define is_unit_firing() \
	not(or(getUnitWeaponFireTime, getUnitWeaponWaitDelay));

// -------------------------------------------------------------
// elapsed_since_variable_time

#define elapsed_since_variable_time(p_varname) \
  elapsedMissionTime; \
  setSecondary; \
  getVariable p_varname; \
  decreaseSecondary; \
  getSecondary;

// -------------------------------------------------------------
// variable_to_elapsed_time

#define variable_to_elapsed_time(p_varname) \
  elapsedMissionTime; \
  setVariable p_varname; 

// -------------------------------------------------------------
// execute_once

#define execute_once()  if; \
    getUnitVariable executed; \
  then; \
    return; \
  endif; \
  set_unit_var(executed,1);

// -------------------------------------------------------------
// hide_and_disable_hostiles

#define hide_and_disable_hostiles() \
  setPlayer 0; \
  disableUnitAITemporarilyForAllHostiles; \
  clearTargetForAllHostiles; \
  stopAllHostiles; \
  hideAllHostiles;

// -------------------------------------------------------------
// show_and_enable_hostiles

#define show_and_enable_hostiles() \
  setPlayer 0; \
  enableUnitAITemporarilyForAllHostiles; \
  showAllHostiles;

// -------------------------------------------------------------
// unit_execute_tip

#define unit_execute_tip(p_textname) \
  setString p_textname; \
  setUnitExecuteTipToStringValue; \
  startScriptProcessForUnit unit_execute_tip;

// -------------------------------------------------------------
// unit_execute_tip_high_priority

#define unit_execute_tip_high_priority(p_textname) \
  setString p_textname; \
  setUnitExecuteTipToStringValue; \
  startScriptProcessForUnit unit_execute_tip_high_priority;

// -------------------------------------------------------------

#define force_player_execute_enabled() \
	pushValue; \
	setValue 0; \
	forceControllerKeyEnabled execute; \
	popValue;

#define set_respawn_position(id) \
  setUnitByIdString id;\
  getUnitId;\
  restoreUnit;\
  setUnitVariable unittype_custom1;\
  externInclude respawn_location:execute

// -------------------------------------------------------------
// more...

#define disable_teleport(id) \
  setUnitByIdString id;disableUnitAI; \
  disableParticleSpawnerByName id; \
  getDecorByName id;\
  disableDecorEffect "rotate_y"

#define enable_teleport(id) \
  setUnitByIdString id;enableUnitAI; \
  enableParticleSpawnerByName id; \
  getDecorByName id;\
  enableDecorEffect "rotate_y"

#include "char_interaction_macros.h"
#include "unittype_macro_defs.h"
#include "ambientsound_macros.h"
#include "ani_and_camera_macros.h"
#include "upgrade_macros.h"


