
#define P_UNIFY2(a,b) P_MAKE_UNIFIED2(a,b)
#define P_MAKE_UNIFIED2(a,b) a##b

// -----------

#define UPG_SCRIPT(p_upg_name) \
  P_UNIFY2(UPG_NAME,_upgrade)


#define UPG_COMMON_VAR(p_upg_name) \
  permanentGlobal int,P_UNIFY2(upgraded_,p_upg_name);


#define UPG_COMMON_APPLY_SUB(p_upg_name, p_upg_for_part) \
  if; \
    not(getVariable P_UNIFY2(upgraded_,p_upg_name)); \
  then; \
    return; \
  endif; \
  \
  toRootPart; \
  if; \
    not(seekSubPart p_upg_for_part); \
  then; \
    return; \
  endif;


// return
// 0 if upgrade has already been applied
//      or weapon to upgrade is not available
// 1 if weapon was available, and not yet upgraded, so can upgrade
#define UPG_COMMON_CAN_SUB(p_upg_name, p_upg_for_part) \
  if; \
    getVariable P_UNIFY2(upgraded_,p_upg_name); \
  then; \
    setValue 0; \
    return; \
  endif; \
	\
  toRootPart; \
  if; \
    not(seekSubPart p_upg_for_part); \
  then; \
    setValue 0; \
    return; \
  endif; \
	\
  setValue 1;


#define UPG_COMMON_UPGRADE_SUB(p_upg_name) \
  if; \
    not(call can_upgrade); \
  then; \
    error("attempt to upgrade part when it cannot be upgraded."); \
    return; \
  endif; \
  \
  set_var(P_UNIFY2(upgraded_,p_upg_name), 1); \
  \
  call apply;


// NOTE: NOT PROPERLY IMPLEMENTED  
// would need some kind of pendingUpgradeApply
#define UPG_COMMON_DOWNGRADE_SUB(p_upg_name) \
  set_var(P_UNIFY2(upgraded_,p_upg_name), 0);


// would need some kind of pendingUpgradeApply
#define UPG_COMMON_IS_UPGRADED_SUB(p_upg_name) \
  getVariable P_UNIFY2(upgraded_,p_upg_name);

